# OpalFaxEndPoint Class Reference

`#include <t38proto.h>`

Inheritance diagram for OpalFaxEndPoint:

[legend]
Collaboration diagram for OpalFaxEndPoint:
[legend]

## Public Member Functions

Construction
| OpalFaxEndPoint (OpalManager &manager, const char *g711Prefix="fax", const char *t38Prefix="t38")
| ~OpalFaxEndPoint ()
Overrides from OpalEndPoint
virtual PSafePtr< OpalConnection > | MakeConnection (OpalCall &call, const PString &party, void *userData=NULL, unsigned int options=0, OpalConnection::StringOptions *stringOptions=NULL)
virtual OpalMediaFormatList | GetMediaFormats () const
Fax specific operations
virtual bool | IsAvailable () const
virtual OpalFaxConnection * | CreateConnection (OpalCall &call, void *userData, OpalConnection::StringOptions *stringOptions, const PString &filename, bool receiving, bool disableT38)
virtual void | OnFaxCompleted (OpalFaxConnection &connection, bool failed)
Member variable access
const PString & | GetDefaultDirectory () const
void | SetDefaultDirectory (const PString &dir)
const PString & | GetT38Prefix () const

## Protected Attributes

PString | m_t38Prefix
PDirectory | m_defaultDirectory

## Detailed Description

Fax Endpoint. This class represents connection that can take a standard group 3 fax TIFF file and produce either T.38 packets or actual tones represented by a stream of PCM. For T.38 it is expected the second connection in the call supports T.38 e.g. SIP or H.323. If PCM is being used then the second connection may be anything that supports PCM, such as SIP or H.323 using G.711 codec or OpalLineEndpoint which could the send the TIFF file to a physical fax machine.

Relies on the presence of the spandsp plug in to do the hard work.

## Constructor & Destructor Documentation

OpalFaxEndPoint::OpalFaxEndPoint | ( | OpalManager & | manager,
|  | const char * | g711Prefix = `"fax"`,
|  | const char * | t38Prefix = `"t38"` |
| ) |  |  |

Create a new endpoint.

Parameters:

  manager | Manager of all endpoints.
  g711Prefix | Prefix for URL style address strings
  t38Prefix | Prefix for URL style address strings

OpalFaxEndPoint::~OpalFaxEndPoint | ( |  | ) |

Destroy endpoint.

## Member Function Documentation

virtual OpalFaxConnection* OpalFaxEndPoint::CreateConnection | ( | OpalCall & | call,
|  | void * | userData,
|  | OpalConnection::StringOptions * | stringOptions,
|  | const PString & | filename,
|  | bool | receiving,
|  | bool | disableT38 |
| ) |  |  | `[virtual]`

Create a connection for the fax endpoint.

Parameters:

  call | Owner of connection
  userData | Arbitrary data to pass to connection
  stringOptions | Options to pass to connection
  filename | filename to send/receive
  receiving | Flag for receiving/sending fax
  disableT38 | Flag to disable use of T.38

const PString& OpalFaxEndPoint::GetDefaultDirectory | ( |  | ) | const`[inline]`

Get the default directory for received faxes.

virtual OpalMediaFormatList OpalFaxEndPoint::GetMediaFormats | ( |  | ) | const`[virtual]`

Get the data formats this endpoint is capable of operating. This provides a list of media data format names that may be used by an OpalMediaStream may be created by a connection from this endpoint.

Note that a specific connection may not actually support all of the media formats returned here, but should return no more.

Reimplemented from OpalLocalEndPoint.

const PString& OpalFaxEndPoint::GetT38Prefix | ( |  | ) | const`[inline]`

virtual bool OpalFaxEndPoint::IsAvailable | ( |  | ) | const`[virtual]`

Determine if the fax plug in is available, that is fax system can be used.

virtual PSafePtr<OpalConnection> OpalFaxEndPoint::MakeConnection | ( | OpalCall & | call,
|  | const PString & | party,
|  | void * | userData = `NULL`,
|  | unsigned int | options = `0`,
|  | OpalConnection::StringOptions * | stringOptions = `NULL` |
| ) |  |  | `[virtual]`

Set up a connection to a remote party. This is called from the OpalManager::MakeConnection() function once it has determined that this is the endpoint for the protocol.

The general form for this party parameter is:

[proto:][alias@][transport$]address[:port]

where the various fields will have meanings specific to the endpoint type. For example, with H.323 it could be "h323:Fred@site.com" which indicates a user Fred at gatekeeper size.com. Whereas for the PSTN endpoint it could be "pstn:5551234" which is to call 5551234 on the first available PSTN line.

The proto field is optional when passed to a specific endpoint. If it is present, however, it must agree with the endpoints protocol name or false is returned.

This function usually returns almost immediately with the connection continuing to occur in a new background thread.

If false is returned then the connection could not be established. For example if a PSTN endpoint is used and the assiciated line is engaged then it may return immediately. Returning a non-NULL value does not mean that the connection will succeed, only that an attempt is being made.

The default behaviour is pure.

Parameters:

  call | Owner of connection
  party | Remote party to call
  userData | Arbitrary data to pass to connection
  options | options to pass to conneciton
  stringOptions | Options to pass to connection

Reimplemented from OpalLocalEndPoint.

virtual void OpalFaxEndPoint::OnFaxCompleted | ( | OpalFaxConnection & | connection,
|  | bool | failed |
| ) |  |  | `[virtual]`

Fax transmission/receipt completed. Default behaviour releases the connection.

Parameters:

  connection | Connection that completed.
  failed | Fax ended with failure

void OpalFaxEndPoint::SetDefaultDirectory | ( | const PString & | dir | ) | `[inline]`

Set the default directory for received faxes.

Parameters:

  dir | New directory for fax reception

## Field Documentation

PDirectory OpalFaxEndPoint::m_defaultDirectory `[protected]`

PString OpalFaxEndPoint::m_t38Prefix `[protected]`

The documentation for this class was generated from the following file:

- t38proto.h